/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "MPU6050.h"
#include "myI2C.h"



void MPU6050_I2C_Init()
{
    I2C_Start();
    //I2C_InitTypeDef I2C_InitStructure;
    //GPIO_InitTypeDef GPIO_InitStructure;

    /* Enable I2C and GPIO clocks */
    //RCC_APB1PeriphClockCmd(MPU6050_I2C_RCC_Periph, ENABLE);
    //RCC_APB2PeriphClockCmd(MPU6050_I2C_RCC_Port, ENABLE);

    /* Configure I2C pins: SCL and SDA */
    //GPIO_InitStructure.GPIO_Pin = MPU6050_I2C_SCL_Pin | MPU6050_I2C_SDA_Pin;
    //GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
    //GPIO_Init(MPU6050_I2C_Port, &GPIO_InitStructure);

    /* I2C configuration */
    //I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
    //I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
    //I2C_InitStructure.I2C_OwnAddress1 = MPU6050_DEFAULT_ADDRESS; // MPU6050 7-bit adress = 0x68, 8-bit adress = 0xD0;
    //I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
    //I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
    //I2C_InitStructure.I2C_ClockSpeed = MPU6050_I2C_Speed;

    /* Apply I2C configuration after enabling it */
    //I2C_Init(MPU6050_I2C, &I2C_InitStructure);
    /* I2C Peripheral Enable */
    //I2C_Cmd(MPU6050_I2C, ENABLE);
}

/**
 * @brief  Writes one byte to the  MPU6050.
 * @param  slaveAddr : slave address MPU6050_DEFAULT_ADDRESS
 * @param  pBuffer : pointer to the buffer  containing the data to be written to the MPU6050.
 * @param  writeAddr : address of the register in which the data will be written
 * @return None
 */
void MPU6050_I2C_ByteWrite(uint8_t slaveAddr, uint8_t* pBuffer, uint8_t writeAddr)
{
    uint8 temp;
    uint8 wr_buffer[2];
    wr_buffer[0] = writeAddr;
    wr_buffer[1] = *pBuffer;

    temp = I2C_MasterWriteBuf(slaveAddr, wr_buffer, 2, I2C_MODE_COMPLETE_XFER);
    //if(temp != I2C_MSTR_NO_ERROR)...

        /* Wait for the data transfer to complete */

       while(I2C_MasterStatus() & I2C_MSTAT_XFER_INP);
       I2C_MasterClearStatus();
    
    
    // ENTR_CRT_SECTION();

    /* Send START condition */
    //I2C_GenerateSTART(MPU6050_I2C, ENABLE);

    /* Test on EV5 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_MODE_SELECT));

    /* Send MPU6050 address for write */
    //I2C_Send7bitAddress(MPU6050_I2C, slaveAddr, I2C_Direction_Transmitter);

    /* Test on EV6 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));

    /* Send the MPU6050's internal address to write to */
    //I2C_SendData(MPU6050_I2C, writeAddr);

    /* Test on EV8 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_BYTE_TRANSMITTED));

    /* Send the byte to be written */
    //I2C_SendData(MPU6050_I2C, *pBuffer);

    /* Test on EV8 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_BYTE_TRANSMITTED));

    /* Send STOP condition */
    //I2C_GenerateSTOP(MPU6050_I2C, ENABLE);

    // EXT_CRT_SECTION();
}

/**
 * @brief  Reads a block of data from the MPU6050.
 * @param  slaveAddr  : slave address MPU6050_DEFAULT_ADDRESS
 * @param  pBuffer : pointer to the buffer that receives the data read from the MPU6050.
 * @param  readAddr : MPU6050's internal address to read from.
 * @param  NumByteToRead : number of bytes to read from the MPU6050 ( NumByteToRead >1  only for the Mgnetometer readinf).
 * @return None
 */
void MPU6050_I2C_BufferRead(uint8_t slaveAddr, uint8_t* pBuffer, uint8_t readAddr, int NumByteToRead)
{
     volatile uint8 temp;
    //uint8 wr_buffer[NumByteToRead];
    //wr_buffer[0] = readAddr;
    *pBuffer = readAddr;
    

/*    temp = I2C_MasterWriteBuf(DEVICE, wr_buffer, 1, I2C_MODE_COMPLETE_XFER);
    //if(temp != I2C_MSTR_NO_ERROR)...
       while(I2C_MasterStatus() & I2C_MSTAT_XFER_INP);
       I2C_MasterClearStatus();
    
    temp = I2C_MasterReadBuf(DEVICE, wr_buffer, 1, I2C_MODE_COMPLETE_XFER);
           while(I2C_MasterStatus() & I2C_MSTAT_XFER_INP);
       I2C_MasterClearStatus();
  */  
    temp = I2C_MasterWriteBuf(slaveAddr, pBuffer, 1, I2C_MODE_NO_STOP);
    //if(temp != I2C_MSTR_NO_ERROR)...
       while((I2C_MasterStatus() & I2C_MSTAT_XFER_HALT)!=I2C_MSTAT_XFER_HALT);
       I2C_MasterClearStatus();
    
       temp = I2C_MasterReadBuf(slaveAddr, pBuffer, NumByteToRead, I2C_MODE_REPEAT_START);
       while(I2C_MasterStatus() & I2C_MSTAT_XFER_INP);
       I2C_MasterClearStatus();
    
//    return wr_buffer[0];
 
}   
    
    // ENTR_CRT_SECTION();

    /* While the bus is busy */
    //while (I2C_GetFlagStatus(MPU6050_I2C, I2C_FLAG_BUSY));

    /* Send START condition */
    //I2C_GenerateSTART(MPU6050_I2C, ENABLE);

    /* Test on EV5 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_MODE_SELECT));

    /* Send MPU6050 address for write */
    //I2C_Send7bitAddress(MPU6050_I2C, slaveAddr, I2C_Direction_Transmitter);

    /* Test on EV6 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));

    /* Clear EV6 by setting again the PE bit */
    //I2C_Cmd(MPU6050_I2C, ENABLE);

    /* Send the MPU6050's internal address to write to */
    //I2C_SendData(MPU6050_I2C, readAddr);

    /* Test on EV8 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_BYTE_TRANSMITTED));

    /* Send STRAT condition a second time */
    //I2C_GenerateSTART(MPU6050_I2C, ENABLE);

    /* Test on EV5 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_MODE_SELECT));

    /* Send MPU6050 address for read */
    //I2C_Send7bitAddress(MPU6050_I2C, slaveAddr, I2C_Direction_Receiver);

    /* Test on EV6 and clear it */
    //while (!I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));

    /* While there is data to be read */
    //while (NumByteToRead)
    //{
    //    if (NumByteToRead == 1)
    //    {
            /* Disable Acknowledgement */
     //       I2C_AcknowledgeConfig(MPU6050_I2C, DISABLE);

            /* Send STOP Condition */
     //       I2C_GenerateSTOP(MPU6050_I2C, ENABLE);
     //   }

        /* Test on EV7 and clear it */
    //    if (I2C_CheckEvent(MPU6050_I2C, I2C_EVENT_MASTER_BYTE_RECEIVED))
    //    {
            /* Read a byte from the MPU6050 */
    //        *pBuffer = I2C_ReceiveData(MPU6050_I2C);

            /* Point to the next location where the byte read will be saved */
    //        pBuffer++;

            /* Decrement the read bytes counter */
    //        NumByteToRead--;
    //    }
    //}

    /* Enable Acknowledgement to be ready for another reception */
    //I2C_AcknowledgeConfig(MPU6050_I2C, ENABLE);
    // EXT_CRT_SECTION();
//}
/* [] END OF FILE */
